package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo.p2j_test.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in test_denormalization.p).
 */
public class TestDenormalization
{
   Person.Buf person = RecordBuffer.define(Person.Buf.class, "p2j_test", "person", "person");

   integer i = new integer(0);

   WhereExpression whereExpr0 = new WhereExpression()
   {
      public logical evaluate(final BaseDataType[] args)
      {
         return isEqual(person.getSchedule(minus((plus(minus(minus(minus(person.getEmpNum(), modulo(i, 3)), 172), 222), 2)), 1)), "aa");
      }
   };

   /**
    * External procedure (converted to Java from the 4GL source code
    * in test_denormalization.p).
    */
   public void execute()
   {
      externalProcedure(new Block()
      {
         handle h = new handle();

         logical l = new logical(false);

         public void init()
         {
            TransactionManager.register(i, h, l);
         }

         public void body()
         {
            RecordBuffer.openScope(person);
            person.deleteAll();
            
            ToClause toClause0 = new ToClause(i, 1, 4);
            
            repeatTo(TransactionType.FULL, "loopLabel0", toClause0, new Block()
            {
               public void body()
               {
                  person.create();
                  person.setScheduleFifth(new character("aa"));
                  person.setSchedule1(person.getScheduleFifth());
                  person.setSsn(concat("aassn_", chr(plus(i, 83))));
                  person.setLastName(concat("last-name_", chr(plus(i, 83))));
                  person.setMiddleInit(new character(""));
                  person.setFirstName(new character("A.B"));
                  person.setEmpNum(plus(plus(modulo(i, 3), multiply(172, i)), 222));
                  person.setExtension(concat("sext+", chr(plus(i, 83))));
                  person.setSiteId(plus(plus(modulo(i, 3), multiply(172, i)), 222));
               }
            });
            
            i.assign(3);
            new FindQuery(person, (String) null, null, "person.siteId asc, person.empNum asc").first();
            new FindQuery(person, "upper(person.schedule[0]) = upper(person.schedule[?])", null, "person.siteId asc, person.empNum asc", new Object[]
            {
               minus((i), 1)
            }).first();
            new FindQuery(person, "upper(person.schedule[?]) = upper(person.schedule[?])", null, "person.siteId asc, person.empNum asc", new Object[]
            {
               minus((i), 1),
               minus((i), 1)
            }).first();
            new FindQuery(person, (String) null, null, "person.siteId asc, person.empNum asc").first();
            
            repeat("loopLabel1", new Block()
            {
               public void body()
               {
                  QueryWrapper.createQuery(h);
                  handle.unwrapQuery(h).addBuffer(new handle(person));
                  ErrorManager.silentErrorEnable();
                  l.assign(handle.unwrapQuery(h).prepare("for each person where person.schedule[1] = 'aa'"));
                  ErrorManager.silentErrorDisable();
                  handle.unwrapQuery(h).queryOpen();
                  message((character) new FieldReference(person, "lastName").getValue());
                  leave("loopLabel1");
               }
            });
            
            new FindQuery(person, "upper(person.schedule[0]) = upper(person.schedule[3])", null, "person.siteId asc, person.empNum asc").first();
            if (person._available())
            {
               message("FOUND");
            }
            
            forEach(TransactionType.FULL, "loopLabel2", new Block()
            {
               PreselectQuery query1 = null;

               public void init()
               {
                  query1 = new PreselectQuery(person, "upper(person.schedule[0]) = upper(person.schedule[3])", null, "person.siteId asc, person.empNum asc");
               }

               public void body()
               {
                  query1.next();
                  person.deleteRecord();
               }
            });
            
            person.deleteAll();
            message("delete all for permanent 1");
            message("delete all for permanent 2");
            
            ToClause toClause1 = new ToClause(i, 1, 4);
            
            repeatTo(TransactionType.FULL, "loopLabel3", toClause1, new Block()
            {
               public void body()
               {
                  person.create();
                  person.setSchedule(minus((i), 1), person.getSchedule(minus((plus(i, 1)), 1)));
                  person.setSsn(concat("aassn_", chr(plus(i, 83))));
                  person.setLastName(new character(""));
                  person.setMiddleInit(new character(""));
                  person.setFirstName(new character("A.B"));
                  person.setEmpNum(plus(plus(modulo(i, 3), multiply(172, i)), 222));
                  person.setExtension(concat("sext+", chr(plus(i, 83))));
                  person.setSiteId(plus(plus(modulo(i, 3), multiply(172, i)), 222));
               }
            });
            
            i.assign(3);
            new FindQuery(person, "upper(person.schedule[?]) = upper(person.schedule[?])", null, "person.siteId asc, person.empNum asc", new Object[]
            {
               minus((i), 1),
               minus((plus(i, 1)), 1)
            }).first();
            if (person._available())
            {
               message("FOUND");
            }
            
            forEach(TransactionType.FULL, "loopLabel4", new Block()
            {
               PreselectQuery query3 = null;

               public void init()
               {
                  query3 = new PreselectQuery(person, "upper(person.schedule[?]) = upper(person.schedule[?])", null, "person.siteId asc, person.empNum asc", new Object[]
                  {
                     minus((i), 1),
                     minus((plus(i, 1)), 1)
                  });
               }

               public void body()
               {
                  query3.next();
                  person.deleteRecord();
               }
            });
            
            person.deleteAll();
            message("delete all for permanent 3");
            message("delete all for permanent 4");
            
            ToClause toClause2 = new ToClause(i, 1, 4);
            
            repeatTo(TransactionType.FULL, "loopLabel5", toClause2, new Block()
            {
               public void body()
               {
                  person.create();
                  person.setSchedule1(new character("aa"));
                  person.setSchedule(minus((plus(i, 1)), 1), person.getSchedule1());
                  person.setSsn(concat("aassn_", chr(plus(i, 83))));
                  person.setLastName(new character(""));
                  person.setMiddleInit(new character(""));
                  person.setFirstName(new character("A.B"));
                  person.setEmpNum(plus(plus(modulo(i, 3), multiply(172, i)), 222));
                  person.setExtension(concat("sext+", chr(plus(i, 83))));
                  person.setSiteId(plus(plus(modulo(i, 3), multiply(172, i)), 222));
               }
            });
            
            i.assign(2);
            RecordBuffer.prepare(person);
            new FindQuery(person, "upper(person.schedule[?]) = 'AA'", null, "person.siteId asc, person.empNum asc", new Object[]
            {
               minus((int64.maximum(plus(i, 2), plus(i, 1))), 1)
            }).first();
            if (person._available())
            {
               message("FOUND");
            }
            new FindQuery(person, (String) null, whereExpr0, "person.siteId asc, person.empNum asc").first();
            if (person._available())
            {
               message("FOUND");
            }
            
            forEach(TransactionType.FULL, "loopLabel6", new Block()
            {
               PreselectQuery query5 = null;

               public void init()
               {
                  RecordBuffer.prepare(person);
                  query5 = new PreselectQuery(person, "upper(person.schedule[?]) = ?", null, "person.siteId asc, person.empNum asc", new Object[]
                  {
                     minus((i), 1),
                     toUpperCase(concat("aassn_", chr(plus(i, 83))))
                  });
               }

               public void body()
               {
                  query5.next();
                  person.deleteRecord();
               }
            });
            
            message("delete all for permanent 5");
            message("delete all for permanent 6");
         }
      });
   }
}
